import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Calendar;
import java.util.*;
import java.util.List;
import java.util.ArrayList;
import java.awt.Color;

/**
 * Write a description of class Tank_World here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Tank_World extends World
{
    boolean crosshair = true;//whose turn it is to shoot
    Counter counter = new Counter("Score: ");
    private Projectile projectile;
    private Projectile_3 projectile_3;
    int explosionX = 0;
    int explosionY = 0; //where to put the explosion
    int level = 0; //level we are in
    boolean am;
    int[] sunrise ={
        8, 7, 8, 7, 7, 6, 7, 7, 7, 8, 7,8
    };
    int[] sunset ={
        6, 6, 8, 8, 9, 9, 9,8, 8, 7, 6,6
    };
    int[] enemy={
            1, 2, 2, 3, 2, 4, 5, 4, 3,5,4, 3, 2,4,4, 5, 4, 5, 3, 4, 5, 4, 3,5,4, 3, 5,4
        };//number of enemies in levels
    int[] Rock={
            150, 300, 230, 200, 200, 200, 300, 200, 250,260, 270, 280, 240,300, 
            230, 200, 200, 200, 300, 200, 250,260, 270, 280, 240
        };// position of rocks in different levels
    int[] place2={
        150,0,0,0,0,0,0,0,0,0,0,0,0,0
    };//position of enemy tanks
    GreenfootImage back;
    int death = 0; // number of tanks killed in level
    boolean time = false; //whether or not we should start next level
    int turn = 0; //which enemy tank is supposed to fire
    int miss = 0; //how many times you have missed
    GreenfootImage day=new GreenfootImage("Field.png");
    GreenfootImage night=new GreenfootImage("Night.png");
    int mY = 0;
    int mX = 0;
    boolean pause = true;
    /**
     * Constructor for objects of class Tank_World.
     * 
     */
    public Tank_World()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        whatTime();
        addObject(new Red_Tank(), 450, 310);
        addObject(new Red_Tank_Arm(), 450, 310);
        //addObject(new Red_Tank_Crosshair(), 300, 200);
        addObject(new Green_Tank(), 150, 310);
        addObject(new Green_Tank_Arm(), 150, 310);
        addObject(new Rock(), 250, 310);
        //addObject(new Tree(), 100, 250);
        addObject(counter, 100, 100);
        projectile = new Projectile(am);
        projectile_3 = new Projectile_3(am);
        Greenfoot.start();
    }
    public int getScore()
    {
        return death;
    }
    public void drawAngle()
    {
        if(pause){getBackground().drawImage(back,0,0);
        getBackground().setColor(Color.red);
        for(int i=0;i<10;i++)
        {
            getBackground().fillOval(450+(i*(mX-450))/10,310+(i*(mY-310))/10,5,5);
        }}
    }
    public void whatTime()
    {
        Calendar today = Calendar.getInstance();
        int second = today.get(Calendar.HOUR);
        int time = today.get(Calendar.AM_PM);
        int month = today.get(Calendar.MONTH);
        if(time == Calendar.AM)
        {
            if(second < sunrise[month]+1){
                setBackground(night);
                back = night;
                am = false;
            }
            else{
                setBackground(day);
                addObject(new Sun(), second*25, 150 + (12 - second)*(90/(13 - sunrise[month])));
                back = day;
                am = true;
            }
        }
        else
        {
            if(second > sunset[month]-1){
                setBackground(night);
                back = night;
                am = false;
            }
            else{
                setBackground(day);
                back = day;
                addObject(new Sun(), 300 + (second*25), 150 + (second)*(90/(12 - sunrise[month])));
                am = true;
            }
        }
    }
    public void act()
    {
        drawAngle();
        MouseChange.setImage();
        if(Greenfoot.isKeyDown("a"))
            pause = false;
        if(Greenfoot.mouseClicked(null))
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if(crosshair == true)
            {    
                addObject(new Projectile(am), 450, 310);
                List<Green_Tank> man = getObjects(Green_Tank.class);
                int x = man.get(0).getX();
                addObject(new Projectile_3(am), x, 300);
            }
        }
        if(Greenfoot.mouseMoved(null))
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            mX = mouse.getX();
            mY = mouse.getY();
        }
    }
    public void count()//counts enemy tanks killed in level determines whether to start next level
    {
        death++;
        counter.add(1);
        int e = (enemy[level]-1);
        if(death > e)
        {
           time = true;
        }
        if(time == true)
        {
            level++;
            start_next_level();
            death = 0;
            time = false;
        }
    }
    public void start_next_level()
    {
        //removeObjects(getObjects(Rock.class));
        removeObjects(getObjects(Tanks.class));
        removeObjects(getObjects(Rock.class));
        addObject(new Rock(), Rock[level], 310);
        for(int g = 0; g < enemy[level]; g++){
            int z = Greenfoot.getRandomNumber(20);
            addObject(new Green_Tank_Arm(), 50+ (z*6), 310);
            addObject(new Green_Tank(), 55+ (z*6), 310);
            place2[g] = 50+(z*6);
        }
        addObject(new Red_Tank_Arm(), 450, 310);
        addObject(new Red_Tank(), 450, 310);
    }
    public void kill()//adds explosion after projectile hits something
    {
        if(getObjects(Projectile.class) != null){
            addObject(new Explosion(), explosionX, explosionY);
            removeObjects(getObjects(Projectile.class));
        }
    }
    public void kill2()//adds explosion after projectile_3 hits something
    {
        addObject(new Explosion(), explosionX, explosionY);
        removeObjects(getObjects(Projectile_3.class));
    }
    public void Dye()//adds the scoreboard telling you what level you were on
    {
            UserInfo me = UserInfo.getMyInfo();
            if (me != null)
            {
                if (counter.value > me.getScore())
                {
                    // It's a high-score, only update the score if ours is now higher:
                    me.setScore(counter.value);
                    
                    me.store();
                }
            }
            Greenfoot.setWorld(new ScoreWorld(600, 400));
    }
}
